package com.omnicorp.servertest;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "com.omnicorp.servertest", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "com.omnicorp.servertest", "main");
        processBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.randomaccessfile.AsyncStreams _astreams = null;
public static anywheresoftware.b4a.objects.SocketWrapper.ServerSocketWrapper _server = null;
public static anywheresoftware.b4a.objects.SocketWrapper _socket1 = null;
public anywheresoftware.b4a.objects.WebViewWrapper _webview1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _cmd1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _cmd2 = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbl = null;
public http _http = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 16;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 17;BA.debugLine="Server.Initialize(http.DefaultPort, \"Server\")";
_server.Initialize(processBA,mostCurrent._http._defaultport,"Server");
 //BA.debugLineNum = 18;BA.debugLine="Server.Listen";
_server.Listen();
 //BA.debugLineNum = 20;BA.debugLine="http.AddDefaultDirectories";
mostCurrent._http._adddefaultdirectories(mostCurrent.activityBA);
 };
 //BA.debugLineNum = 23;BA.debugLine="lbl.Initialize(\"Label\")";
mostCurrent._lbl.Initialize(mostCurrent.activityBA,"Label");
 //BA.debugLineNum = 24;BA.debugLine="ShowURL(\"\")";
_showurl("");
 //BA.debugLineNum = 25;BA.debugLine="activity.AddView(lbl, 0,0, 100%x, 30)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._lbl.getObject()),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),(int)(30));
 //BA.debugLineNum = 27;BA.debugLine="cmd1.Initialize(\"CMD1\")";
mostCurrent._cmd1.Initialize(mostCurrent.activityBA,"CMD1");
 //BA.debugLineNum = 28;BA.debugLine="cmd1.Text= \"Test locally\"";
mostCurrent._cmd1.setText((Object)("Test locally"));
 //BA.debugLineNum = 29;BA.debugLine="activity.AddView(cmd1, 0,30, 50%x, 50)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._cmd1.getObject()),(int)(0),(int)(30),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(50),mostCurrent.activityBA),(int)(50));
 //BA.debugLineNum = 31;BA.debugLine="cmd2.Initialize(\"CMD2\")";
mostCurrent._cmd2.Initialize(mostCurrent.activityBA,"CMD2");
 //BA.debugLineNum = 32;BA.debugLine="cmd2.Text= \"Test via localhost\"";
mostCurrent._cmd2.setText((Object)("Test via localhost"));
 //BA.debugLineNum = 33;BA.debugLine="activity.AddView(cmd2, 50%x,30, 50%x, 50)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._cmd2.getObject()),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(50),mostCurrent.activityBA),(int)(30),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(50),mostCurrent.activityBA),(int)(50));
 //BA.debugLineNum = 35;BA.debugLine="webview1.Initialize(\"WebView1\")";
mostCurrent._webview1.Initialize(mostCurrent.activityBA,"WebView1");
 //BA.debugLineNum = 36;BA.debugLine="webview1.JavaScriptEnabled=True";
mostCurrent._webview1.setJavaScriptEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 37;BA.debugLine="activity.AddView(WebView1, 0,80,100%x, activity.Height-80)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._webview1.getObject()),(int)(0),(int)(80),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),(int)(mostCurrent._activity.getHeight()-80));
 //BA.debugLineNum = 38;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 60;BA.debugLine="Sub Activity_Pause(UserClosed As Boolean)";
 //BA.debugLineNum = 61;BA.debugLine="Server.Close";
_server.Close();
 //BA.debugLineNum = 62;BA.debugLine="If UserClosed Then";
if (_userclosed) { 
 //BA.debugLineNum = 63;BA.debugLine="AStreams.Close";
_astreams.Close();
 //BA.debugLineNum = 64;BA.debugLine="Socket1.Close";
_socket1.Close();
 };
 //BA.debugLineNum = 66;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 56;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 57;BA.debugLine="Server.Listen";
_server.Listen();
 //BA.debugLineNum = 58;BA.debugLine="End Sub";
return "";
}
public static String  _astreams_error() throws Exception{
 //BA.debugLineNum = 91;BA.debugLine="Sub AStreams_Error";
 //BA.debugLineNum = 92;BA.debugLine="ToastMessageShow(LastException.Message, True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 93;BA.debugLine="End Sub";
return "";
}
public static String  _astreams_newdata(byte[] _buffer) throws Exception{
http._filepath _fn = null;
String _msg = "";
 //BA.debugLineNum = 82;BA.debugLine="Sub AStreams_NewData (Buffer() As Byte)";
 //BA.debugLineNum = 84;BA.debugLine="Dim FN As Filepath";
_fn = new http._filepath();
 //BA.debugLineNum = 85;BA.debugLine="msg = http.HandleGetRequest(Buffer, AStreams)";
_msg = mostCurrent._http._handlegetrequest(mostCurrent.activityBA,_buffer,_astreams);
 //BA.debugLineNum = 86;BA.debugLine="fn = http.MapDirectory(msg)";
_fn = mostCurrent._http._mapdirectory(mostCurrent.activityBA,_msg);
 //BA.debugLineNum = 89;BA.debugLine="End Sub";
return "";
}
public static String  _cmd1_click() throws Exception{
 //BA.debugLineNum = 43;BA.debugLine="Sub CMD1_Click";
 //BA.debugLineNum = 44;BA.debugLine="ShowURL(\"file:///android_asset/test.html\")";
_showurl("file:///android_asset/test.html");
 //BA.debugLineNum = 45;BA.debugLine="WebView1.LoadUrl(\"file:///android_asset/test.html\")";
mostCurrent._webview1.LoadUrl("file:///android_asset/test.html");
 //BA.debugLineNum = 46;BA.debugLine="End Sub";
return "";
}
public static String  _cmd2_click() throws Exception{
 //BA.debugLineNum = 47;BA.debugLine="Sub CMD2_Click";
 //BA.debugLineNum = 48;BA.debugLine="ShowURL(\"http://127.0.0.1:\" & http.DefaultPort & \"/test.html\")";
_showurl("http://127.0.0.1:"+BA.NumberToString(mostCurrent._http._defaultport)+"/test.html");
 //BA.debugLineNum = 49;BA.debugLine="WebView1.LoadUrl(\"http://127.0.0.1:\" & http.DefaultPort & \"/test.html\")";
mostCurrent._webview1.LoadUrl("http://127.0.0.1:"+BA.NumberToString(mostCurrent._http._defaultport)+"/test.html");
 //BA.debugLineNum = 50;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
http._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 9;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 12;BA.debugLine="Dim WebView1 As WebView ,CMD1 As Button ,CMD2 As Button , LBL As Label";
mostCurrent._webview1 = new anywheresoftware.b4a.objects.WebViewWrapper();
mostCurrent._cmd1 = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._cmd2 = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._lbl = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 13;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 2;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 3;BA.debugLine="Dim AStreams As AsyncStreams";
_astreams = new anywheresoftware.b4a.randomaccessfile.AsyncStreams();
 //BA.debugLineNum = 4;BA.debugLine="Dim Server As ServerSocket";
_server = new anywheresoftware.b4a.objects.SocketWrapper.ServerSocketWrapper();
 //BA.debugLineNum = 5;BA.debugLine="Dim Socket1 As Socket";
_socket1 = new anywheresoftware.b4a.objects.SocketWrapper();
 //BA.debugLineNum = 6;BA.debugLine="End Sub";
return "";
}
public static String  _server_newconnection(boolean _successful,anywheresoftware.b4a.objects.SocketWrapper _newsocket) throws Exception{
 //BA.debugLineNum = 68;BA.debugLine="Sub Server_NewConnection (Successful As Boolean, NewSocket As Socket)";
 //BA.debugLineNum = 69;BA.debugLine="If Successful Then";
if (_successful) { 
 //BA.debugLineNum = 71;BA.debugLine="Socket1 = NewSocket";
_socket1 = _newsocket;
 //BA.debugLineNum = 72;BA.debugLine="AStreams.Initialize(Socket1.InputStream, Socket1.OutputStream, \"AStreams\")";
_astreams.Initialize(processBA,_socket1.getInputStream(),_socket1.getOutputStream(),"AStreams");
 }else {
 //BA.debugLineNum = 74;BA.debugLine="ToastMessageShow(LastException.Message, True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),anywheresoftware.b4a.keywords.Common.True);
 };
 //BA.debugLineNum = 76;BA.debugLine="Server.Listen";
_server.Listen();
 //BA.debugLineNum = 77;BA.debugLine="End Sub";
return "";
}
public static String  _showurl(String _url) throws Exception{
 //BA.debugLineNum = 40;BA.debugLine="Sub ShowURL(URL As String)";
 //BA.debugLineNum = 41;BA.debugLine="lbl.Text = \"IP: \" & Server.GetMyIP & \":\" & http.DefaultPort & \" URL: \" & URL";
mostCurrent._lbl.setText((Object)("IP: "+_server.GetMyIP()+":"+BA.NumberToString(mostCurrent._http._defaultport)+" URL: "+_url));
 //BA.debugLineNum = 42;BA.debugLine="End Sub";
return "";
}
public static String  _webview1_pagefinished(String _url) throws Exception{
 //BA.debugLineNum = 52;BA.debugLine="Sub WebView1_PageFinished (Url As String)";
 //BA.debugLineNum = 53;BA.debugLine="ToastMessageShow(\"URL: \" & url, True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("URL: "+_url,anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 54;BA.debugLine="End Sub";
return "";
}
}
